Escape
Date: 2019-10-22

org.jmol.util

## Class Escape

- java.lang.Object
- - org.jmol.util.Escape

-     public class Escape
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Escape()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `drawQuat(javajs.util.Quat q, java.lang.String prefix, java.lang.String id, javajs.util.P3 ptCenter, float scale)`
    `static java.lang.String` | `e(java.lang.Object x)`
    `static java.lang.String` | `eAD(double[] dlist)`
    `static java.lang.String` | `eAF(float[] flist)`
    `static java.lang.String` | `eAI(int[] ilist)`
    `static java.lang.String` | `eAP(javajs.util.T3[] plist)`
    `static java.lang.String` | `eAS(java.lang.String[] list, boolean nicely)`
    `static java.lang.String` | `eBond(javajs.util.BS bs)`
    `static java.lang.String` | `eBS(javajs.util.BS bs)`
    `static java.lang.String` | `encapsulateData(java.lang.String name, java.lang.Object data, int depth)`
    `static java.lang.String` | `eP(javajs.util.T3 xyz)` must be its own, because of the possibility of being null
    `static java.lang.String` | `eP4(javajs.util.P4 x)`
    `static java.lang.String` | `escapeColor(int argb)`
    `static java.lang.String` | `escapeFloatA(float[] f, boolean asArray)`
    `static java.lang.String` | `escapeFloatAA(float[][] f, boolean addSemi)`
    `static java.lang.String` | `escapeFloatAAA(float[][][] f, boolean addSemi)`
    `static java.lang.Object` | `escapeHelical(java.lang.String id, int tokType, javajs.util.P3 a, javajs.util.P3 b, javajs.util.T3[] pts)` Jmol-specific post-processing of the array data returned by Measure.computeHelicalAxis
    `static java.lang.String` | `escapeMap(java.util.Map<java.lang.String,java.lang.Object> ht)`
    `static java.lang.String` | `escapeModelFileNumber(int iv)`
    `private static java.lang.String` | `escapeNice(java.lang.String s)`
    `static java.lang.String` | `eV(javajs.util.Lst<SV> list)`
    `static java.lang.String` | `getHexColorFromRGB(int argb)`
    `static int` | `getHexitValue(char ch)`
    `static boolean` | `isAV(java.lang.Object x)`
    `static boolean` | `isStringArray(java.lang.String s)`
    `static java.lang.String` | `matrixToScript(java.lang.Object m)`
    `private static java.lang.String` | `packageReadable(java.lang.String infoName, java.lang.String infoType, java.lang.String info)`
    `private static java.lang.String` | `packageReadableSb(java.lang.String infoName, java.lang.String infoType, javajs.util.SB sb)`
    `static java.lang.String` | `toReadable(java.lang.String name, java.lang.Object info)` Used only for getProperty("readable",...)
    `static java.lang.Object` | `uABsM(java.lang.String s)`
    `static java.lang.Object` | `unescapeMatrix(java.lang.String strMatrix)`
    `static java.lang.String[]` | `unescapeStringArray(java.lang.String data)`
    `static java.lang.String` | `unescapeUnicode(java.lang.String s)`
    `static java.lang.Object` | `uP(java.lang.String strPoint)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Escape

          public Escape()

  - ### Method Detail

    - #### escapeColor

          public static java.lang.String escapeColor(int argb)

    - #### getHexColorFromRGB

          public static java.lang.String getHexColorFromRGB(int argb)

    - #### eP

          public static java.lang.String eP(javajs.util.T3 xyz)

      must be its own, because of the possibility of being null
      Parameters:
        `xyz` -
      Returns:
        {x y z}

    - #### matrixToScript

          public static java.lang.String matrixToScript(java.lang.Object m)

    - #### eP4

          public static java.lang.String eP4(javajs.util.P4 x)

    - #### drawQuat

          public static java.lang.String drawQuat(javajs.util.Quat q,
                                                  java.lang.String prefix,
                                                  java.lang.String id,
                                                  javajs.util.P3 ptCenter,
                                                  float scale)

    - #### e

          public static java.lang.String e(java.lang.Object x)

    - #### eV

          public static java.lang.String eV(javajs.util.Lst<SV> list)

    - #### escapeMap

          public static java.lang.String escapeMap(java.util.Map<java.lang.String,java.lang.Object> ht)

    - #### escapeFloatA

          public static java.lang.String escapeFloatA(float[] f,
                                                      boolean asArray)

      Parameters:
        `f` -
        `asArray` - -- FALSE allows bypassing of escape(Object f); TRUE: unnecssary
      Returns:
        tabular string

    - #### escapeFloatAA

          public static java.lang.String escapeFloatAA(float[][] f,
                                                       boolean addSemi)

    - #### escapeFloatAAA

          public static java.lang.String escapeFloatAAA(float[][][] f,
                                                        boolean addSemi)

    - #### eAS

          public static java.lang.String eAS(java.lang.String[] list,
                                             boolean nicely)

      Parameters:
        `list` - list of strings to serialize
        `nicely` - TODO
      Returns:
        serialized array

    - #### eAI

          public static java.lang.String eAI(int[] ilist)

    - #### eAD

          public static java.lang.String eAD(double[] dlist)

    - #### eAF

          public static java.lang.String eAF(float[] flist)

    - #### eAP

          public static java.lang.String eAP(javajs.util.T3[] plist)

    - #### escapeNice

          private static java.lang.String escapeNice(java.lang.String s)

    - #### uABsM

          public static java.lang.Object uABsM(java.lang.String s)

    - #### isStringArray

          public static boolean isStringArray(java.lang.String s)

    - #### uP

          public static java.lang.Object uP(java.lang.String strPoint)

    - #### unescapeMatrix

          public static java.lang.Object unescapeMatrix(java.lang.String strMatrix)

    - #### eBS

          public static java.lang.String eBS(javajs.util.BS bs)

    - #### eBond

          public static java.lang.String eBond(javajs.util.BS bs)

    - #### toReadable

          public static java.lang.String toReadable(java.lang.String name,
                                                    java.lang.Object info)

      Used only for getProperty("readable",...)
      Parameters:
        `name` -
        `info` -
      Returns:
        tabular listing, with array types

    - #### packageReadableSb

          private static java.lang.String packageReadableSb(java.lang.String infoName,
                                                            java.lang.String infoType,
                                                            javajs.util.SB sb)

    - #### packageReadable

          private static java.lang.String packageReadable(java.lang.String infoName,
                                                          java.lang.String infoType,
                                                          java.lang.String info)

    - #### escapeModelFileNumber

          public static java.lang.String escapeModelFileNumber(int iv)

    - #### encapsulateData

          public static java.lang.String encapsulateData(java.lang.String name,
                                                         java.lang.Object data,
                                                         int depth)

    - #### unescapeUnicode

          public static java.lang.String unescapeUnicode(java.lang.String s)

    - #### getHexitValue

          public static int getHexitValue(char ch)

    - #### unescapeStringArray

          public static java.lang.String[] unescapeStringArray(java.lang.String data)

    - #### isAV

          public static boolean isAV(java.lang.Object x)

    - #### escapeHelical

          public static java.lang.Object escapeHelical(java.lang.String id,
                                                       int tokType,
                                                       javajs.util.P3 a,
                                                       javajs.util.P3 b,
                                                       javajs.util.T3[] pts)

      Jmol-specific post-processing of the array data returned by Measure.computeHelicalAxis
      Parameters:
        `id` -
        `tokType` -
        `a` -
        `b` -
        `pts` -
      Returns:
        various objects depending upon tokType